import 'package:build/build.dart';
import 'package:dart_style/dart_style.dart';
import 'package:source_gen/source_gen.dart';
import 'dart:core';

import 'src/global_generator.dart';
import 'src/padding_helpers_generator.dart';
import 'src/space_widgets_generator.dart';

const String header = """
// Generated by Neat
//
// This file has been generated
// Do not modify by hand
""";

Builder neatGenerator(BuilderOptions options) {
  final formater = DartFormatter();

  return PartBuilder(
    [
      GlobalGenerator(),
      SpaceWidgetsGenerator(),
      PaddingHelpersGenerator(),
    ],
    ".nt.dart",
    formatOutput: formater.format,
    header: header,
  );
}
